pcl::common::NormalGenerator< T > Class Template Reference

NormalGenerator class generates a random number from a normal distribution specified by (mean, sigma). More...

`#include <pcl/common/random.h>`

## Classes

struct | Parameters

## Public Types

using | DistributionType = typename normal_distribution< T >::type

## Public Member Functions

| NormalGenerator (T mean=0, T sigma=1, std::uint32_t seed=-1)
| Constructor. More...
| NormalGenerator (const Parameters &parameters)
| Constructor. More...
void | setSeed (std::uint32_t seed)
| Change seed value. More...
void | setParameters (T mean, T sigma, std::uint32_t seed=-1)
| Set the normal number generator parameters. More...
void | setParameters (const Parameters &parameters)
| Set generator parameters. More...
const Parameters & | getParameters ()
T | run ()

## Public Attributes

Parameters | parameters_
| parameters More...
std::mt19937 | rng_
| random number generator More...
DistributionType | distribution_
| normal distribution More...

## Detailed Description

### template<typename T>
class pcl::common::NormalGenerator< T >

NormalGenerator class generates a random number from a normal distribution specified by (mean, sigma).

Author
  Nizar Sallem

Definition at line 150 of file random.h.

## Member Typedef Documentation

## DistributionType

template<typename T >

using pcl::common::NormalGenerator< T >::DistributionType = typename normal_distribution<T>::type

Definition at line 206 of file random.h.

## Constructor & Destructor Documentation

## NormalGenerator() [1/2]

template<typename T >

pcl::common::NormalGenerator< T >::NormalGenerator | ( | T | mean = `0`,
|  | T | sigma = `1`,
|  | std::uint32_t | seed = `-1`
| ) |  |

Constructor.

Parameters

  [in] | mean | normal mean
  [in] | sigma | normal variation
  [in] | seed | seeding value

Definition at line 106 of file random.hpp.

References pcl::common::NormalGenerator< T >::parameters_, pcl::common::NormalGenerator< T >::rng_, and pcl::common::NormalGenerator< T >::Parameters::seed.

## NormalGenerator() [2/2]

template<typename T >

pcl::common::NormalGenerator< T >::NormalGenerator | ( | const Parameters & | parameters | ) |

Constructor.

Parameters

  parameters | normal distribution parameters and seed

Definition at line 117 of file random.hpp.

References pcl::common::NormalGenerator< T >::parameters_, pcl::common::NormalGenerator< T >::rng_, and pcl::common::NormalGenerator< T >::Parameters::seed.

## Member Function Documentation

## getParameters()

template<typename T >

const Parameters& pcl::common::NormalGenerator< T >::getParameters | ( |  | ) |

inline

Returns
  normal distribution parameters and generator seed

Definition at line 200 of file random.h.

References pcl::common::NormalGenerator< T >::parameters_.

## run()

template<typename T >

T pcl::common::NormalGenerator< T >::run | ( |  | ) |

inline

Returns
  a randomly generated number in the normal distribution (mean, sigma)

Definition at line 204 of file random.h.

References pcl::common::NormalGenerator< T >::distribution_, and pcl::common::NormalGenerator< T >::rng_.

## setParameters() [1/2]

template<typename T >

void pcl::common::NormalGenerator< T >::setParameters | ( | const Parameters & | parameters | ) |

Set generator parameters.

Parameters

  parameters | normal distribution parameters and seed

Definition at line 152 of file random.hpp.

## setParameters() [2/2]

template<typename T >

void pcl::common::NormalGenerator< T >::setParameters | ( | T | mean,
|  | T | sigma,
|  | std::uint32_t | seed = `-1`
| ) |  |

Set the normal number generator parameters.

Parameters

  [in] | mean | mean of the normal distribution
  [in] | sigma | standard variation of the normal distribution
  [in] | seed | random number generator seed (applied if != -1)

Definition at line 138 of file random.hpp.

## setSeed()

template<typename T >

void pcl::common::NormalGenerator< T >::setSeed | ( | std::uint32_t | seed | ) |

Change seed value.

Parameters

  [in] | seed | new seed value

Definition at line 127 of file random.hpp.

## Member Data Documentation

## distribution_

template<typename T >

DistributionType pcl::common::NormalGenerator< T >::distribution_

normal distribution

Definition at line 212 of file random.h.

Referenced by pcl::common::NormalGenerator< T >::run().

## parameters_

template<typename T >

Parameters pcl::common::NormalGenerator< T >::parameters_

parameters

Definition at line 208 of file random.h.

Referenced by pcl::common::NormalGenerator< T >::getParameters(), and pcl::common::NormalGenerator< T >::NormalGenerator().

## rng_

template<typename T >

std::mt19937 pcl::common::NormalGenerator< T >::rng_

random number generator

Definition at line 210 of file random.h.

Referenced by pcl::common::NormalGenerator< T >::NormalGenerator(), and pcl::common::NormalGenerator< T >::run().

The documentation for this class was generated from the following files:

- pcl/common/random.h
- pcl/common/impl/random.hpp